Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34921)
@@ -1818,4 +2500,131 @@
         },
     },
+    0x0080 => { #PH (Q)
+        Name => 'AspectRatio',
+        PrintConv => {
+            0 => '4:3',
+            1 => '3:2',
+            2 => '16:9',
+            3 => '1:1',
+        },
+    },
+    # 0x0081 - int8u: 0 (Q)
+    0x0082 => {
+        Name => 'BlurControl',
+        Writable => 'int8u',
+        Count => 4,
+        PrintConv => [
+            {
+                0 => 'Off',
+                1 => 'Low',
+                2 => 'Medium',
+                3 => 'High',
+            },
+            undef, # 0 with BlurControl is Off, seen 0,1,3 when on (related to subject distance?)
+            undef, # 0 with BlurControl Off, 45 when on
+            undef, # always 0
+        ],
+    },
+    # 0x0083 - int8u: 0 (Q DNG)
+    # 0x0084 - int8u: 0 (Q)
+    0x0085 => { #PH
+        Name => 'HDR',
+        Format => 'int8u',
+        Count => 4,
+        PrintConv => [{ # (K-01,K-3)
+            0 => 'Off',
+            1 => 'HDR Auto',
+            2 => 'HDR 1',
+            3 => 'HDR 2',
+            4 => 'HDR 3',
+            5 => 'HDR Advanced', #29 (K-1)
+        },{ # (K-01)
+            0 => 'Auto-align Off',
+            1 => 'Auto-align On',
+        },{
+            # not sure about this - PH
+            # - you can set HDR "Exposure Bracket Value" with the K-3
+            # - guessed from imaging-resource K-3 samples K3OUTBHDR_A{1,2,3}
+            0 => 'n/a',
+            4 => '1 EV',
+            8 => '2 EV',
+            12 => '3 EV', # (get this from K-01, but can't set EV)
+        },
+        # (4th number is always 0)
+        ],
+    },
+    # 0x0086 - int8u: 0, 111[Sport,Pet] (Q) - related to Tracking FocusMode?
+    # 0x0087 - int8u: 0 (Q)
+    0x0087 => { #PH
+        Name => 'ShutterType',
+        Writable => 'int8u',
+        PrintConv => {
+            0 => 'Normal', # ('Mechanical' if the camera has a mechanical shutter)
+            1 => 'Electronic', # (KP)
+        },
+    },
+    0x0088 => { #PH
+        Name => 'NeutralDensityFilter',
+        Writable => 'int8u',
+        Count => -1,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            '0 2' => 'Off (0 2)', #PH (NC, GR III)
+            '1 2' => 'On (1 2)', #PH (NC, GR III)
+        },
+    },
+    0x008b => { #PH (LS465)
+        Name => 'ISO',
+        Priority => 0,
+        Writable => 'int32u',
+    },
+    0x0092 => { #31
+        Name => 'IntervalShooting',
+        Notes => '2 numbers: 1. Shot number 2. Total number of shots',
+        Writable => 'int16u',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'Off',
+            OTHER => sub {
+                my ($val, $inv) = @_;
+                if ($inv) {
+                    $val =~ tr/0-9 //dc;
+                } else {
+                    $val =~ s/(\d+) (\d+)/Shot $1 of $2/;
+                }
+                return $val;
+            },
+        },
+    },
+    0x0095 => { #31
+        Name => 'SkinToneCorrection',
+        Writable => 'int8s',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'Off',
+            '1 1' => 'On (type 1)',
+            '1 2' => 'On (type 2)',
+        },
+    },
+    0x0096 => { #31
+        Name => 'ClarityControl',
+        Writable => 'int8s',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'Off',
+            OTHER => sub {
+                my ($val, $inv) = @_;
+                if ($inv) {
+                    $val =~ /(\d+ -?\d+)/ and return $1;
+                    return ("1 $val");
+                } elsif ($val =~ /^1 (-?\d+)$/) {
+                    return $1 ? sprintf('%+d', $1) : 0;
+                } else {
+                    return "Unknown ($val)";
+                }
+            },
+        },
+    },
     0x0200 => { #5
         Name => 'BlackPoint',
@@ -1834,5 +2643,5 @@
     # 0x0202: int16u[4]: all 0's in all my samples
     0x0203 => { #JD (not really sure what these mean)
-        Name => 'ColorMatrixA',
+        Name => 'ColorMatrixA', # (camera RGB to sRGB matrix, *ist D, ref IB)
         Writable => 'int16s',
         Count => 9,
@@ -1843,5 +2652,5 @@
     },
     0x0204 => { #JD
-        Name => 'ColorMatrixB',
+        Name => 'ColorMatrixB', # (camera RGB to Adobe RGB matrix, *ist D, ref IB)
         Writable => 'int16s',
         Count => 9,
@@ -1851,15 +2660,41 @@
         PrintConvInv => '"$val"',
     },
-    0x0205 => { #19
+    0x0205 => [{ #19
         Name => 'CameraSettings',
+        # size: *istD/*istDs/K100D/K110D=16, K-m/K2000=14, K-7/K-x=19,
+        #       K200D/K20D/K-5/645D=20, K-r=21, K10D=22, K-01=25
+        Condition => '$count < 25', # (not valid for the K-01)
         SubDirectory => {
             TagTable => 'Image::ExifTool::Pentax::CameraSettings',
             ByteOrder => 'BigEndian',
         },
-    },
-    0x0206 => { #PH
+    },{
+        Name => 'CameraSettingsUnknown',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Pentax::CameraSettingsUnknown',
+            ByteOrder => 'BigEndian',
+        },
+    }],
+    0x0206 => [{ #PH
         Name => 'AEInfo',
+        # size: *istD/*istDs/K100D/K110D=14, K10D/K200D/K20D=16, K-m/K2000=20,
+        #        K-7/K-x=24, K-5/K-r/645D=25
+        Condition => '$count <= 25 and $count != 21 and $$self{AEInfoSize} = $count',
         SubDirectory => { TagTable => 'Image::ExifTool::Pentax::AEInfo' },
-    },
+    },{
+        Name => 'AEInfo2',
+        # size: K-01=21
+        Condition => '$count == 21',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::AEInfo2' },
+    },{
+        Name => 'AEInfo3',
+        # size: K-30=48
+        Condition => '$count == 48',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::AEInfo3' },
+    },{
+        Name => 'AEInfoUnknown',
+        # size: Q/Q10=34
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::AEInfoUnknown' },
+    }],
     0x0207 => [ #PH
         {
@@ -1876,14 +2711,20 @@
         },{
             Name => 'LensInfo',
-            Condition => '$count < 90',
+            Condition => '$count != 90 and $count != 91 and $count != 80 and $count != 128 and $count != 168',
             SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensInfo2' },
         },{
-            Name => 'LensInfo',
+            Name => 'LensInfo', # 645D
             Condition => '$count == 90',
             SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensInfo3' },
         },{
-            Name => 'LensInfo',
+            Name => 'LensInfo', # K-r, K-5, K-5II
+            Condition => '$count == 91',
             SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensInfo4' },
+        },{
+            Name => 'LensInfo', # K-01, K-30, K-50, K-500, K-3, K-3II
+            Condition => '$count == 80 or $count == 128',
+            SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensInfo5' },
         }
+        # ($count == 168 - Ricoh GR III)
     ],
     0x0208 => [ #PH
@@ -1904,9 +2745,10 @@
         Notes => q{
             measurements from each of the 16 AE metering segments for models such as the
-            K10D, and 77 metering segments for models such as the K-5, converted to LV
+            K10D, 77 metering segments for models such as the K-5, and 4050 metering
+            segments for the K-3, converted to LV
         },
         %convertMeteringSegments,
-        #    16 metering segment             77 metering segment
-        #    locations (ref JD)              locations (ref PH, K-5)
+        #  16 metering segment              77 metering segment
+        #  locations (ref JD, K10D)         locations (ref PH, K-5)
         # +-------------------------+
         # |           14            | +----------------------------------+
@@ -1986,5 +2828,5 @@
         },
     },
-    # 0x021a - undef[1068] (K-5)
+    # 0x021a - undef[1068] (K-5) - ToneMode/Saturation mapping matrices (ref 28)
     0x021b => { #19
         Name => 'SaturationInfo',
@@ -2003,5 +2845,5 @@
     # 0x021c - undef[18] (K-5)
     # 0x021d - undef[18] (K-5)
-    # 0x021e - undef[8] (K-5)
+    # 0x021e - undef[8] (K-5, Q)
     0x021f => { #JD
         Name => 'AFInfo',
@@ -2019,7 +2861,10 @@
         Flags => [ 'Unknown', 'Binary' ],
         Writable => 0,
-        Notes => 'found in K10D, K20D and K2000D PEF images',
-    },
-    # 0x0221 - undef[138] (K-5)
+        Notes => 'found in K10D, K20D and K2000 PEF images',
+    },
+    0x0221 => { #28
+        Name => 'KelvinWB',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::KelvinWB' },
+    },
     0x0222 => { #PH
         Name => 'ColorInfo',
@@ -2029,4 +2874,5 @@
     0x0224 => { #19
         Name => 'EVStepInfo',
+        Drop => 200, # drop if larger than 200 bytes (40 kB in Pentax Q and Q10)
         SubDirectory => { TagTable => 'Image::ExifTool::Pentax::EVStepInfo' },
     },
@@ -2050,5 +2896,12 @@
         Notes => 'left blank by some cameras',
     },
-    0x022a => { #PH (K-5)
+    0x022a => [{ #PH (RICOH models (GR III))
+        Name => 'FilterInfo',
+        Condition => '$$self{Make} =~ /^RICOH/',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Pentax::FilterInfo',
+            ByteOrder => 'LittleEndian',
+        },
+    },{ #PH (K-5)
         Name => 'FilterInfo',
         SubDirectory => {
@@ -2056,5 +2909,5 @@
             ByteOrder => 'BigEndian',
         },
-    },
+    }],
     0x022b => { #PH (K-5)
         Name => 'LevelInfo',
@@ -2062,5 +2915,9 @@
     },
     # 0x022c - undef[46] (K-5)
-    # 0x022d - undef[100] (K-5)
+    0x022d => { #28
+        Name => 'WBLevels',
+        Condition => '$count == 100', # (just to be safe, but no other counts observed)
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::WBLevels' },
+    },
     0x022e => { #PH (K-5 AVI videos)
         Name => 'Artist',
@@ -2073,8 +2930,8 @@
         Writable => 'string',
     },
-    0x0230 => { #PH (K-x AVI videos)
+    0x0230 => { #PH (K-x AVI videos) (and K-70/Q-S1 MOV videos, ref 31)
         Name => 'FirmwareVersion',
-        Notes => 'only in AVI videos',
-        # this tag only exists in AVI videos, and for the K-x the value of
+        Notes => 'only in videos',
+        # this tag only exists in AVI/MOV videos, and for the K-x the value of
         # this tag is "K-x Ver 1.00", which is the same as the EXIF Software
         # tag.  I used a different tag name for this because Pentax uses the
@@ -2098,4 +2955,28 @@
         Count => 10,
     },
+    # 0x0236 - undef[52] (Q)
+    # 0x0237 - undef[11] possibly related to smart effect setting? (Q)
+    # 0x0238 - undef[9] (Q)
+    0x0239 => { #PH
+        Name => 'LensInfoQ',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensInfoQ' },
+    },
+    # 0x023a - undef[10] (Q)
+    # 0x023b - undef[9] (K-01)
+    #  01a700500000000000, 91a700500000000000, 41a700500000000000, 002700500000000000
+    #  c00500400000000000, 400500500000000000, 4004ff420100000000, 4087ff480000000000
+    0x023f => { #31 (K-70 MOV videos)
+        Name => 'Model',
+        Description => 'Camera Model Name',
+        Writable => 'string',
+    },
+    0x0243 => { #PH
+        Name => 'PixelShiftInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::PixelShiftInfo' },
+    },
+    0x0245 => { #29
+        Name => 'AFPointInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::AFPointInfo' },
+    },
     0x03fe => { #PH
         Name => 'DataDump',
@@ -2105,7 +2986,7 @@
     0x03ff => [ #PH
         {
-            Name => 'TempInfoK5',
-            Condition => '$$self{Model} =~ /K-5\b/',
-            SubDirectory => { TagTable => 'Image::ExifTool::Pentax::TempInfoK5' },
+            Name => 'TempInfo',
+            Condition => '$$self{Model} =~ /K-(01|3|30|5|50|500)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Pentax::TempInfo' },
         },{
             Name => 'UnknownInfo',
@@ -2122,6 +3003,13 @@
     },
     # 0x0404 - undef[2086] (K-5)
-    # 0x0405 - undef[24200] (K-5 PEF/DNG only)
+    0x0405 => { #PH - undef[24200] (K-5 PEF/DNG only), undef[28672] (Q DNG)
+        Name => 'UnknownBlock',
+        Writable => 'undef',
+        Notes => 'large unknown data block in PEF/DNG images but not JPG images',
+        Flags => [ 'Unknown', 'Binary', 'Drop' ],
+    },
     # 0x0406 - undef[4116] (K-5)
+    # 0x0407 - undef[3072] (Q DNG)
+    # 0x0408 - undef[1024] (Q DNG)
     0x0e00 => {
         Name => 'PrintIM',
@@ -2157,9 +3045,13 @@
             1 => 'On',
             4 => 'Off (4)', # (K20D, K200D, K-7, K-5)
-            5 => 'On (5)', #(guess) (K20D)
-            # (got 5 for K-5 with HDR [auto-align off only], Composition Adjust, and movie with SR off!)
+            5 => 'On but Disabled', # (K20D, K-5)
+            # (can be 5 "On but Disabled" for K-5 with HDR [auto-align off only],
+            # Composition Adjust, DriveMode = Self-timer or Remote, and movie with SR off!)
             6 => 'On (Video)', # (K-7)
             7 => 'On (7)', #(NC) (K20D, K200D, K-m, K-5)
-            15 => 'On (15)', # (K20D (with Tamron 10-20mm @ 10mm))
+            15 => 'On (15)', # (K20D with Tamron 10-20mm @ 10mm)
+            39 => 'On (mode 2)', # (K-01) (on during capture and live view)
+            135 => 'On (135)', # (K-5IIs)
+            167 => 'On (mode 1)', # (K-01) (on during capture only)
         },
     },
@@ -2169,7 +3061,8 @@
         # (from http://www.patentstorm.us/patents/6597867-description.html)
         # (here, SR could more accurately mean Shutter Release, not Shake Reduction)
+        # (not valid for K-01 - PH)
         Notes => q{
             time from when the shutter button was half pressed to when the shutter was
-            released, including time for focusing
+            released, including time for focusing.  Not valid for some models
         },
         # (constant of 60 determined from times: 2sec=127; 3sec=184,197; 4sec=244,249,243,246 - PH)
@@ -2185,4 +3078,37 @@
         PrintConv => '"$val mm"',
         PrintConvInv => '$val=~s/\s*mm//;$val',
+    },
+);
+
+# shake reduction information for the K-3 (ref PH)
+%Image::ExifTool::Pentax::SRInfo2 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Shake reduction information for the K-3.',
+    0 => {
+        Name => 'SRResult',
+        Unknown => 1,
+        PrintConv => { BITMASK => {
+            # Bit 0 - have seen this set in a few Pentax samples - PH
+            # Bit 6 - usually set when SR is Off, and occasionally when On - PH
+            # Bit 7 - set when AA simulation is on - PH
+        }},
+    },
+    1 => {
+        Name => 'ShakeReduction',
+        PrintConv => { #forum5425
+            0 => 'Off', # (NC for K-3)
+            1 => 'On', # (NC for K-3)
+            4 => 'Off (AA simulation off)',
+            5 => 'On but Disabled', # (NC for K-3)
+            6 => 'On (Video)', # (NC for K-3)
+            7 => 'On (AA simulation off)',
+            8 => 'Off (AA simulation type 1) (8)', #forum8362 (K-70)
+            12 => 'Off (AA simulation type 1)', # (AA linear motion)
+            15 => 'On (AA simulation type 1)', # (AA linear motion)
+            16 => 'Off (AA simulation type 2) (16)', #forum8362 (K-70)
+            20 => 'Off (AA simulation type 2)', # (AA circular motion)
+            23 => 'On (AA simulation type 2)', # (AA circular motion)
+        },
     },
 );
@@ -2237,6 +3163,6 @@
         Mask => 0x01,
         PrintConv => {
-            0x00 => 'Hometown',
-            0x01 => 'Destination',
+            0 => 'Hometown',
+            1 => 'Destination',
         },
     },
@@ -2244,16 +3170,10 @@
         Name => 'HometownDST',
         Mask => 0x02,
-        PrintConv => {
-            0x00 => 'No',
-            0x02 => 'Yes',
-        },
+        PrintConv => \%noYes,
     },
     0.3 => {
         Name => 'DestinationDST',
         Mask => 0x04,
-        PrintConv => {
-            0x00 => 'No',
-            0x04 => 'Yes',
-        },
+        PrintConv => \%noYes,
     },
     2 => {
@@ -2281,4 +3201,12 @@
         PrintConv => { 0 => 'Off', 1 => 'On' },
     },
+    2 => {
+        Name => 'PeripheralIlluminationCorr',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    3 => {
+        Name => 'DiffractionCorrection',
+        PrintConv => { 0 => 'Off', 16 => 'On' },
+    },
 );
 
@@ -2288,5 +3216,5 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     PRIORITY => 0,
-    NOTES => 'Shot information written by Pentax DSLR cameras.',
+    NOTES => 'Camera settings information written by Pentax DSLR cameras.',
     0 => {
         Name => 'PictureMode2',
@@ -2325,6 +3253,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => '1/2 EV Steps',
-            0x20 => '1/3 EV Steps',
+            0 => '1/2 EV Steps',
+            1 => '1/3 EV Steps',
         },
     },
@@ -2334,6 +3262,6 @@
         Mask => 0x40,
         PrintConv => {
-            0x00 => 'Tv or Av',
-            0x40 => 'P Shift',
+            0 => 'Tv or Av',
+            1 => 'P Shift',
         },
     },
@@ -2343,6 +3271,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => 'Prohibited',
-            0x80 => 'Permitted',
+            0 => 'Prohibited',
+            1 => 'Permitted',
         },
     },
@@ -2351,6 +3279,4 @@
         Notes => 'the camera flash options settings, set even if the flash is off',
         Mask => 0xf0,
-        ValueConv => '$val>>4',
-        ValueConvInv => '$val<<4',
         # Note: These tags correlate with the FlashMode and InternalFlashMode values,
         # and match what is displayed by the Pentax software
@@ -2370,5 +3296,5 @@
         Name => 'MeteringMode2',
         Mask => 0x0f,
-        Notes => 'may not be valid for some models, ie. *ist D',
+        Notes => 'may not be valid for some models, eg. *ist D',
         PrintConv => {
             0 => 'Multi-segment',
@@ -2383,9 +3309,9 @@
         Mask => 0xf0,
         PrintConv => {
-            0x00 => 'Auto',
+            0 => 'Auto',
             BITMASK => {
-                4 => 'Select',
-                5 => 'Fixed Center',
-                # have seen bit 6 set in pre-production images (firmware 0.20) - PH
+                0 => 'Select',
+                1 => 'Fixed Center',
+                # have seen bit 2 set in pre-production images (firmware 0.20) - PH
             },
         },
@@ -2446,5 +3372,5 @@
         Name => 'ExposureBracketStepSize',
         # This is set even when Exposure Bracket is Off (and the K10D
-        # displays Ò---Ó as the step size when you press the EB button) - DaveN
+        # displays "---" as the step size when you press the EB button) - DaveN
         # because the last value is remembered and if you turn Exposure Bracket
         # on the step size goes back to what it was before.
@@ -2485,18 +3411,18 @@
         PrintConv => {
             0 => 'Auto',
-            16 => 'Daylight',
-            32 => 'Shade',
-            48 => 'Cloudy',
-            64 => 'Daylight Fluorescent',
-            80 => 'Day White Fluorescent',
-            96 => 'White Fluorescent',
-            112 => 'Tungsten',
-            128 => 'Flash',
-            144 => 'Manual',
+            1 => 'Daylight',
+            2 => 'Shade',
+            3 => 'Cloudy',
+            4 => 'Daylight Fluorescent',
+            5 => 'Day White Fluorescent',
+            6 => 'White Fluorescent',
+            7 => 'Tungsten',
+            8 => 'Flash',
+            9 => 'Manual',
             # The three Set Color Temperature settings refer to the 3 preset settings which
             # can be saved in the menu (see page 123 of the K10D manual)
-            192 => 'Set Color Temperature 1',
-            208 => 'Set Color Temperature 2',
-            224 => 'Set Color Temperature 3',
+            12 => 'Set Color Temperature 1',
+            13 => 'Set Color Temperature 2',
+            14 => 'Set Color Temperature 3',
         },
     },
@@ -2551,8 +3477,5 @@
         Notes => 'K-5 only',
         Mask => 0x01,
-        PrintConv => {
-            0x00 => 'Off',
-            0x01 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     14.3 => { #PH (K-5)
@@ -2562,6 +3485,6 @@
         Mask => 0x02,
         PrintConv => {
-            0x00 => '1 EV Steps',
-            0x02 => 'As EV Steps',
+            0 => '1 EV Steps',
+            1 => 'As EV Steps',
         },
     },
@@ -2571,8 +3494,5 @@
         Notes => 'K-5 only',
         Mask => 0x04,
-        PrintConv => {
-            0x00 => 'Off',
-            0x04 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     # 14.5 Mask 0x80 - changes for K-5
@@ -2589,13 +3509,13 @@
         # (these tags relate closely to InternalFlashMode values - PH)
         PrintConv => {
-            0x00 => 'Normal', # (this value never occurs in Green Mode) - ref 19
-            0x10 => 'Red-eye reduction', # (this value never occurs in Green Mode) - ref 19
-            0x20 => 'Auto',  # (this value only occurs in Green Mode) - ref 19
-            0x30 => 'Auto, Red-eye reduction', # (this value only occurs in Green Mode) - ref 19
-            0x50 => 'Wireless (Master)',
-            0x60 => 'Wireless (Control)',
-            0x80 => 'Slow-sync',
-            0x90 => 'Slow-sync, Red-eye reduction',
-            0xa0 => 'Trailing-curtain Sync'
+            0 => 'Normal', # (this value never occurs in Green Mode) - ref 19
+            1 => 'Red-eye reduction', # (this value never occurs in Green Mode) - ref 19
+            2 => 'Auto',  # (this value only occurs in Green Mode) - ref 19
+            3 => 'Auto, Red-eye reduction', # (this value only occurs in Green Mode) - ref 19
+            5 => 'Wireless (Master)',
+            6 => 'Wireless (Control)',
+            8 => 'Slow-sync',
+            9 => 'Slow-sync, Red-eye reduction',
+            10 => 'Trailing-curtain Sync'
         },
     },
@@ -2622,8 +3542,5 @@
         },
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'No',
-            0x80 => 'Yes',
-        },
+        PrintConv => \%noYes,
     },
     17.2 => {
@@ -2633,8 +3550,8 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => 'Horizontal (normal)',
-            0x20 => 'Rotate 180',
-            0x40 => 'Rotate 90 CW',
-            0x60 => 'Rotate 270 CW',
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 180',
+            2 => 'Rotate 90 CW',
+            3 => 'Rotate 270 CW',
         },
     },
@@ -2647,6 +3564,6 @@
         Mask => 0x04,
         PrintConv => {
-            0x00 => 'Manual',
-            0x04 => 'Auto',
+            0 => 'Manual',
+            1 => 'Auto',
         },
     },
@@ -2657,6 +3574,6 @@
         Mask => 0x02,
         PrintConv => {
-            0x00 => '1 EV Steps',
-            0x02 => 'As EV Steps',
+            0 => '1 EV Steps',
+            1 => 'As EV Steps',
         },
     },
@@ -2704,10 +3621,18 @@
 );
 
+# unknown camera settings (K-01)
+%Image::ExifTool::Pentax::CameraSettingsUnknown = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'This information has not yet been decoded for models such as the K-01.',
+);
+
 # auto-exposure information (ref PH)
 %Image::ExifTool::Pentax::AEInfo = (
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    DATAMEMBER => [ 8 ],
-    # instead of /8, should these be PentaxEV(), as in CameraSettings? - PH
+    DATAMEMBER => [ 7 ],
+    NOTES => 'Auto-exposure information for most Pentax models.',
+    # instead of /8, should these be PentaxEv(), as in CameraSettings? - PH
     0 => {
         Name => 'AEExposureTime',
@@ -2777,18 +3702,30 @@
             83 => 'No Flash',
             91 => 'Night Scene',
+            # 96 - seen for Pentax Q10
             99 => 'Surf & Snow',
+            104 => 'Night Snap', # (Q)
             107 => 'Text',
             115 => 'Sunset',
+            # 116 - seen for Pentax Q (vivid?)
             123 => 'Kids',
             131 => 'Pet',
             139 => 'Candlelight',
+            144 => 'SCN', # (Q)
+            160 => 'Program', # (Q)
+            # 142 - seen for Pentax Q in Program mode
             147 => 'Museum',
             184 => 'Shallow DOF Program', # (K-5)
+            216 => 'HDR', # (Q)
         },
     },
     7 => {
         Name => 'AEFlags',
-        Unknown => 1,
         Writable => 0,
+        Hook => '$size > 20 and $varSize += 1',
+        Notes => 'indices after this are incremented by 1 for some models',
+        # (this tag can't be unknown because the Hook must be evaluated
+        #  to shift the following offsets if necessary.  Instead, ignore
+        #  the return value unless Unknown option used)
+        RawConv => '$$self{OPTIONS}{Unknown} ? $val : undef',
         PrintConv => { #19
             # (seems to be the warnings displayed in the viewfinder for several bits)
@@ -2808,16 +3745,16 @@
         },
     },
-    8 => {
-        Name => 'AEUnknown',
-        Notes => 'indices after this are incremented by 1 for some models',
-        Format => 'var_int8u[$size > 20 ? 2 : 1]',
-        Writable => 0,
-        # (this tag can't be unknown because the Format must be evaluated
-        #  to shift the following offsets if necessary.  Instead, ignore
-        #  the return value unless Unknown > 1)
-        RawConv => '$$self{OPTIONS}{Unknown} > 1 ? $val : undef',
-    },
     # Note: Offsets below shifted by 1 if record size is > 20 bytes
-    # (implemented by the var_int8u count above)
+    # (implemented by the Hook above)
+    8 => { #30
+        Name => 'AEApertureSteps',
+        Notes => q{
+            number of steps the aperture has been stopped down from wide open.  There
+            are roughly 8 steps per F-stop for most lenses, or 18 steps for 645D lenses,
+            but it varies slightly by lens
+        },
+        PrintConv => '$val == 255 ? "n/a" : $val',
+        PrintConvInv => '$val eq "n/a" ? 255 : $val',
+    },
     9 => { #19
         Name => 'AEMaxAperture',
@@ -2854,7 +3791,38 @@
         },
     },
-    # 13 - related to program mode somehow - PH
+    13 => { #30
+        Name => 'AEWhiteBalance',
+        Condition => '$$self{AEInfoSize} == 24', # (not thoroughly tested for other sizes)
+        Notes => 'K7 and Kx',
+        Mask => 0xf0,
+        PrintConv => {
+            0 => 'Standard',
+            1 => 'Daylight',
+            2 => 'Shade',
+            3 => 'Cloudy',
+            4 => 'Daylight Fluorescent',
+            5 => 'Day White Fluorescent',
+            6 => 'White Fluorescent',
+            7 => 'Tungsten',
+            8 => 'Unknown', #31 (or not set due to inadequate lighting)
+        },
+    },
+    13.1 => { #30
+        Name => 'AEMeteringMode2',
+        Condition => '$$self{AEInfoSize} == 24', # (not thoroughly tested for other sizes)
+        Notes => 'K7 and Kx, override for an incompatible metering mode setting',
+        Mask => 0x0f,
+        PrintConv => {
+            0 => 'Multi-segment',
+            BITMASK => {
+                0 => 'Center-weighted average',
+                1 => 'Spot',
+                # 2 - seen for K7 AVI movie
+            },
+        },
+    },
     14 => { #19
         Name => 'FlashExposureCompSet',
+        Description => 'Flash Exposure Comp. Setting',
         Format => 'int8s',
         Notes => q{
